// pages/demo/demo.js
var Api = require('../../utils/api.js');
var util = require('../../utils/util.js');
var app = getApp();
// canvas 全局配置
var context = null; // 使用 wx.createContext 获取绘图上下文 context
var isButtonDown = false;
var arrx = [];
var arry = [];
var arrz = [];
var canvasw = 0;
var canvash = 0;
//获取系统信息
wx.getSystemInfo({
  success: function (res) {
    canvasw = res.windowWidth; //设备宽度
    canvash = res.windowHeight
  }
});
Page({
  canvasIdErrorCallback: function (e) {
    console.error(e.detail.errMsg)
  },
  //开始
  canvasStart: function (event) {
    isButtonDown = true;
    arrz.push(0);
    arrx.push(event.changedTouches[0].x);
    arry.push(event.changedTouches[0].y);


  },
  //过程
  canvasMove: function (event) {
    if (isButtonDown) {
      arrz.push(1);
      arrx.push(event.changedTouches[0].x);
      arry.push(event.changedTouches[0].y);


    };

    for (var i = 0; i < arrx.length; i++) {
      if (arrz[i] == 0) {
        context.moveTo(arrx[i], arry[i])
      } else {
        context.lineTo(arrx[i], arry[i])
      };

    };
    context.clearRect(0, 0, canvasw, canvash);

    context.setStrokeStyle('#000000');
    context.setLineWidth(2);
    context.setLineCap('round');
    context.setLineJoin('round');
    context.stroke();

    context.draw(false);
  },
  canvasEnd: function (event) {
    isButtonDown = false;
  },
  cleardraw: function () {
    //清除画布
    arrx = [];
    arry = [];
    arrz = [];
    context.clearRect(0, 0, canvasw, canvash);
    context.draw(true);
  },
  //导出图片
  getimg: function () {
    var that = this
    if (arrx.length == 0) {
      wx.showModal({
        title: '提示',
        content: '签名内容不能为空！',
        showCancel: false
      });
      return false;
    };
    //生成图片
    wx.canvasToTempFilePath({
      canvasId: 'canvas',
      success: function (res) {
        console.log(res.tempFilePath);
        //存入服务器
        wx.uploadFile({
          url: 'https://www.xiaodongai.com/xiaodong_yiyuan/xinli/index.php/Api/UploadFile', //接口地址
          filePath: res.tempFilePath,
          name: 'myFile',
          formData: { //HTTP 请求中其他额外的 form data 
            'user': 'test'
          },
          success: function (res) {
            let data = JSON.parse(res.data)
            if (data.ret == 1) {
              that.setData({
                canvas: false
              })
              wx.setStorageSync('canvas', data.filename)
            } else {
              wx.showToast({
                title: '提交失败',
                icon: 'none',
                duration: 2000
              })
            }
          }
        });
      }
    })
  },
  /**
   * 页面的初始数据
   */
  data: {
    src: "",
    id: 0,
    winH: '',
    winW: '',
    disab: true,
    current: 1,
    flag: true,
    animationData: {},
    item: {
      answer: [],
      con: '',
      active: -1,
      num: '',
      add: '',
      lb_id: '',
      time: '',
    },
    judgeSex: 1,
    pizibao: "", //匹兹堡
    pizibao1: "", //绵竹三院
    hollander: "", //霍兰德职业倾向
    xljksy: "", //心理健康素养
    shzcpd: "", //社会支持评定
    multipleChoice: '', //多选题
    attitudeSurvey: '', //职工心态调查
    sheqv: '',
    ptime1: "22",
    pminute1: "30",
    ptime2: "07",
    pminute2: "30",
    ptime3: "08",
    pminute3: "00",
    nextFalg: {},
    shengfen: '',
    pici: '',
    canvas: false
  },
  onLoad: function (options) {
    // 使用 wx.createContext 获取绘图上下文 context
    context = wx.createCanvasContext('canvas');
    context.beginPath()
    context.setStrokeStyle('#000000');
    context.setLineWidth(4);
    context.setLineCap('round');
    context.setLineJoin('round');
    //清除画布
    arrx = [];
    arry = [];
    arrz = [];
    context.clearRect(0, 0, canvasw, canvash);
    context.draw(true);
    if (options) {
      this.setData({
        bid: options
      })
      if (options.id == 620 || options.id == 626 || options.id == 632 || options.id == 636) {
        this.setData({
          canvas: true
        })
      }
    }
    var otype = options.otype;
    var answer_swiper = wx.getStorageSync('answer_swiper');
    var swiper_arr = wx.getStorageSync('swiper_arr');
    var lb_descript = wx.getStorageSync('lb_descript');
    var yanzhengid = wx.getStorageSync('yanzhengid');
    let len = answer_swiper != '' ? (answer_swiper.answer.length < swiper_arr[1].length ? answer_swiper.answer.length : swiper_arr[1].length - 1) : 0;
    if (len > 9 && (answer_swiper.id == '652' || answer_swiper.id == '656' || answer_swiper.id == '723') && answer_swiper.answer[6] == 0 && answer_swiper.answer[7] == 0&&answer_swiper.answer[8] == 0&&answer_swiper.answer[9] == 0) len = 9;
    if (false) {} else {
      console.log('lb_descript.desc.record_id', lb_descript.desc.record_id)
      if (lb_descript.desc.record_id == -1) {
        this.loadData();
      } else if (yanzhengid == lb_descript.desc.record_id) {
        if (len > 0) {
          var item = swiper_arr[1][len];
          var nextFalg = this.data.nextFalg;
          // 处理最后一题的选择问题
          if (swiper_arr[1].length == answer_swiper.answer.length) {
            var last_len = swiper_arr[1].length - 1; // 最后一题序号
            var ind_len = answer_swiper.answer[last_len]; // 最后答案
            var con_len = swiper_arr[1][last_len].score; //  最后问题的答案
            console.log(answer_swiper.answer[answer_swiper.answer.length - 1], item, 'item')
            for (let i = 0; i < con_len.length; i++) {
              // console.log('????', ind_len,con_len[i])
              if (ind_len == con_len[i]) {
                this.setData({
                  active: i,
                  disab: false,
                  nextFalg: nextFalg
                })
              }
              // 心理咨询认同性
              if (lb_descript.id[0] == 647 && (i == con_len.length - 1)) {
                nextFalg[last_len] = true;
                this.setData({
                  // active: i,
                  disab: false,
                  nextFalg: nextFalg
                })
                let ans = answer_swiper.answer[last_len];
                let ansArr = ans.split('|');
                for (let i = 0; i < ansArr.length; i++) {
                  item.check[ansArr[i]] = 1;
                }
              }
            }
          }
          this.setData({
            item: item,
            current: len,
            all: swiper_arr[1].length,
            nextFalg: nextFalg,
          })

        } else {
          this.loadData();
        }
      } else {
        this.loadData();
      }
    }
  },
  loadData: function () {
    var lb_swiper_con = wx.getStorageSync('lb_swiper_con');
    var lb = lb_swiper_con[1];
    var arr = [];
    var an = ['A.', 'B.', 'C.', 'D.', 'E.', 'F.', 'G.', 'H.', 'I.'];
    let zimu = [];
    for (let j in lb) {
      let le = lb[j].quesion_answer.split(',').length;
      var obj = {
        con: lb[j].quesion_title,
        answer: lb[j].quesion_answer.split(','),
        score: lb[j].quesion_score.split(','),
        type: lb[j].type,
        check: [],
        zimu: an
      }
      obj.check.length = obj.answer.length;
      for (let i = 0; i < obj.answer.length; i++) {
        obj.check[i] = 0;
      }
      arr.push(obj)
    }
    var swiper_arr = [lb_swiper_con[0], arr];

    wx.setStorageSync('swiper_arr', swiper_arr);
    var lb_swiper_con = wx.getStorageSync('lb_swiper_con');
    var answerData = {
      score: [],
      answer: [],
      id: lb_swiper_con[0].measure_id
    }
    var yanzhengid = -1;
    wx.setStorageSync('answer_swiper', answerData);
    wx.setStorageSync('yanzhengid', yanzhengid);
    var timeArr = [];
    wx.setStorageSync("timeArr", timeArr);
    // wx.removeStorageSync('lb_swiper_con')
    var item = swiper_arr[1][0];
    var nextFalg = {
      0: false
    }
    this.setData({
      all: arr.length,
      current: 0,
      item: item,
      nextFalg: nextFalg
    });

    wx.setNavigationBarTitle({
      title: swiper_arr[0].measure_name
    });
  },
  selectData: function (e) {
    // console.log('222', e)
    let that = this;
    // console.log('bid', that.data.bid.id)
    var qufentime = wx.getStorageSync('qufentime');
    var lb_descript = wx.getStorageSync('lb_descript');
    wx.setStorageSync('yanzhengid', lb_descript.desc.record_id);
    // var lb_swiper_con = wx.getStorageSync('lb_swiper_con');
    var swiper_arr = wx.getStorageSync('swiper_arr');
    var answer_swiper = wx.getStorageSync('answer_swiper');
    let len = swiper_arr[1].length;
    if (that.data.bid.id == 632 && e.currentTarget.dataset.record == 18 && e.currentTarget.dataset.score == 1) {
      for (let i = 18; i < 24; i++) {
        if (i == 18) {
          answer_swiper.score[18] = e.currentTarget.dataset.score;
          answer_swiper.answer[18] = 0;
        } else {
          answer_swiper.score[i] = '0';
          answer_swiper.answer[i] = 0;
        }
      }
      var record = 23;
    } else {
      var record = e.currentTarget.dataset.record;
    }
    // console.log(e.currentTarget.dataset.record, 'e.currentTarget.dataset.record')

    if (that.data.bid.id == 632 && answer_swiper.score[18] == 1 && record == 24) {
      console.log('修改成功', answer_swiper.score[18])
      answer_swiper.score[23] = '0';
      answer_swiper.answer[23] = 0;
    }

    var index = e.currentTarget.dataset.index;
    // var answer = e.currentTarget.dataset.answer;
    var score = e.currentTarget.dataset.score;
    var btnFlag = e.currentTarget.dataset.btnflag || 0; // 多选判断  0无多选  1 有多选
    // console.log('btnFlag', btnFlag,e)
    var nextFalg = this.data.nextFalg;
    nextFalg[record] = true;
    this.setData({
      nextFalg: nextFalg
    })
    //量表id652 贝克自杀 判断4，5题选项是否是'没有'
    // console.log('record：', record, answer_swiper.id, answer_swiper.answer[record], index)
    if ((answer_swiper.id == '652' || answer_swiper.id == '656' || answer_swiper.id == '723') && record == 9 && answer_swiper.answer[6] == 0&& answer_swiper.answer[7] == 0  && answer_swiper.answer[8] == 0 && index == 0) {
      len = 10;
    }
    // 判断题长度
    if (record < Number(len) - 1) {
      // 多选判断
      if (this.data.multipleChoice && (this.data.current == 4 || this.data.current == 8 || this.data.current == 9 || this.data.current == 10 || this.data.current == 14)) {
        console.log('1')
        answer_swiper.answer[record] = answer_swiper.answer[record] || '';
        answer_swiper.score[record] = answer_swiper.score[record] || '';
        answer_swiper.score[record]
        var xin_sc = answer_swiper.score[record].split("|");
        var xin_an = answer_swiper.answer[record].toString().split("|");
        let item = this.data.item;
        let l_answer = xin_an.indexOf(index.toString());
        if (l_answer > -1) {
          item.check[index] = 0;
          xin_an.splice(l_answer, 1);
          xin_sc.splice(l_answer, 1);
          index = xin_an.join('|');
          score = xin_sc.join('|');
          index = index.replace(/^\|/, '');
          score = score.replace(/^\|/, '');
        } else {
          console.log('1')
          item.check[index] = 1;
          xin_an.push(index);
          index = xin_an.join('|');
          // ==============
          xin_sc.push(score);
          score = xin_sc.join('|');
          index = index.replace(/^\|/, '');
          score = score.replace(/^\|/, '');
        }
        // }
        this.setData({
          item: item,
        })
      }
      //职工心态调查问卷
      if (this.data.attitudeSurvey && (this.data.current == 4 || this.data.current == 5 || this.data.current == 6 || this.data.current == 7)) {
        console.log('1')
        answer_swiper.answer[record] = answer_swiper.answer[record] || '';
        answer_swiper.score[record] = answer_swiper.score[record] || '';
        answer_swiper.score[record]
        var xin_sc = answer_swiper.score[record].split("|");
        var xin_an = answer_swiper.answer[record].toString().split("|");
        let item = this.data.item;
        let l_answer = xin_an.indexOf(index.toString());
        if (l_answer > -1) {
          item.check[index] = 0;
          xin_an.splice(l_answer, 1);
          xin_sc.splice(l_answer, 1);
          index = xin_an.join('|');
          score = xin_sc.join('|');
          index = index.replace(/^\|/, '');
          score = score.replace(/^\|/, '');
        } else {
          console.log('1')
          item.check[index] = 1;
          xin_an.push(index);
          index = xin_an.join('|');
          // ==============
          xin_sc.push(score);
          score = xin_sc.join('|');
          index = index.replace(/^\|/, '');
          score = score.replace(/^\|/, '');
        }
        // }
        this.setData({
          item: item,
        })
      }
      // 社区工作者
      if (this.data.sheqv && (this.data.current == 12 || this.data.current == 19)) {
        answer_swiper.answer[record] = answer_swiper.answer[record] || '';
        answer_swiper.score[record] = answer_swiper.score[record] || '';
        answer_swiper.score[record]
        var xin_sc = answer_swiper.score[record].split("|");
        var xin_an = answer_swiper.answer[record].toString().split("|");
        let item = this.data.item;
        let l_answer = xin_an.indexOf(index.toString());
        if (l_answer > -1) {
          item.check[index] = 0;
          xin_an.splice(l_answer, 1);
          xin_sc.splice(l_answer, 1);
          index = xin_an.join('|');
          score = xin_sc.join('|');
          index = index.replace(/^\|/, '');
          score = score.replace(/^\|/, '');

        } else {
          console.log('1')
          item.check[index] = 1;
          xin_an.push(index);
          index = xin_an.join('|');
          // ==============
          xin_sc.push(score);
          score = xin_sc.join('|');
          index = index.replace(/^\|/, '');
          score = score.replace(/^\|/, '');
        }
        // }
        this.setData({
          item: item,
        })
      }
      // 以上社区工作者
      this.setData({
        active: index,
        // active: -1,
        all: len,
        current: Number(record)
      })
      //点击不同意
      if (that.data.bid.id == 620) {
        console.log(e.currentTarget.dataset, '888')
        if (e.currentTarget.dataset.score == 2) {
          if (that.data.current == 0) {
            wx.reLaunch({
              url: '/pages/record/record',
              success: function () {
                that.setData({
                  flag: true
                })
              }
            })
            return;
          }
        }
      } else if (that.data.bid.id == 621) {
        console.log(e.currentTarget.dataset.score)
        if (e.currentTarget.dataset.score == 2) {
          if (that.data.current == 0) {
            wx.reLaunch({
              url: '/pages/record/record',
              success: function () {
                that.setData({
                  flag: true
                })
              }
            })
            return;
          }
        }
      } else if (that.data.bid.id == 624) {
        if (e.currentTarget.dataset.score == 2) {
          if (that.data.current == 0) {
            wx.reLaunch({
              url: '/pages/record/record',
              success: function () {
                that.setData({
                  flag: true
                })
              }
            })
            return;
          }
        }
      }
      if (answer_swiper.score.length <= record) {
        answer_swiper.score.push(score);
        answer_swiper.answer.push(index);
        // console.log(score, 'score2')
        // console.log(index, 'index1')
      } else {
        answer_swiper.score[record] = score;
        answer_swiper.answer[record] = index;
        // console.log(score, 'score2')
        // console.log(index, 'index2')
      }
      wx.setStorageSync('answer_swiper', answer_swiper);

      if (btnFlag == 0) { // 无多选
        setTimeout(function () {
          // console.log(record, "record")
          that.next1(record);
        }, 200)
      }

    } else if (record == Number(len) - 1) {
      // 多选判断
      if (this.data.multipleChoice && (this.data.current == 4 || this.data.current == 8 || this.data.current == 9 || this.data.current == 10 || this.data.current == 14)) {
        answer_swiper.answer[record] = answer_swiper.answer[record] || '';
        answer_swiper.score[record] = answer_swiper.score[record] || '';
        answer_swiper.score[record]
        var xin_sc = answer_swiper.score[record].split("|");
        var xin_an = answer_swiper.answer[record].toString().split("|");
        let item = this.data.item;
        let l_answer = xin_an.indexOf(index.toString());
        if (l_answer > -1) {
          item.check[index] = 0;
          xin_an.splice(l_answer, 1);
          xin_sc.splice(l_answer, 1);
          index = xin_an.join('|');
          score = xin_sc.join('|');
          index = index.replace(/^\|/, '');
          score = score.replace(/^\|/, '');
        } else {
          item.check[index] = 1;
          xin_an.push(index);
          index = xin_an.join('|');
          // ==============
          xin_sc.push(score);
          score = xin_sc.join('|');
          index = index.replace(/^\|/, '');
          score = score.replace(/^\|/, '');
        }
        // }
        this.setData({
          item: item,
        })
      }
      if (this.data.attitudeSurvey && (this.data.current == 4 || this.data.current == 5 || this.data.current == 6 || this.data.current == 7)) {
        answer_swiper.answer[record] = answer_swiper.answer[record] || '';
        answer_swiper.score[record] = answer_swiper.score[record] || '';
        answer_swiper.score[record]
        var xin_sc = answer_swiper.score[record].split("|");
        var xin_an = answer_swiper.answer[record].toString().split("|");
        let item = this.data.item;
        let l_answer = xin_an.indexOf(index.toString());
        if (l_answer > -1) {
          item.check[index] = 0;
          xin_an.splice(l_answer, 1);
          xin_sc.splice(l_answer, 1);
          index = xin_an.join('|');
          score = xin_sc.join('|');
          index = index.replace(/^\|/, '');
          score = score.replace(/^\|/, '');
        } else {
          item.check[index] = 1;
          xin_an.push(index);
          index = xin_an.join('|');
          // ==============
          xin_sc.push(score);
          score = xin_sc.join('|');
          index = index.replace(/^\|/, '');
          score = score.replace(/^\|/, '');
        }
        // }
        this.setData({
          item: item,
        })
      }
      // 社区工作者
      if (this.data.multipleChoice && (this.data.current == 4 || this.data.current == 8 || this.data.current == 9 || this.data.current == 10 || this.data.current == 14)) {
        answer_swiper.answer[record] = answer_swiper.answer[record] || '';
        answer_swiper.score[record] = answer_swiper.score[record] || '';
        answer_swiper.score[record]
        var xin_sc = answer_swiper.score[record].split("|");
        var xin_an = answer_swiper.answer[record].toString().split("|");
        let item = this.data.item;
        let l_answer = xin_an.indexOf(index.toString());
        if (l_answer > -1) {
          item.check[index] = 0;
          xin_an.splice(l_answer, 1);
          xin_sc.splice(l_answer, 1);
          index = xin_an.join('|');
          score = xin_sc.join('|');
          index = index.replace(/^\|/, '');
          score = score.replace(/^\|/, '');

        } else {
          item.check[index] = 1;
          xin_an.push(index);
          index = xin_an.join('|');
          // ==============
          xin_sc.push(score);
          score = xin_sc.join('|');
          index = index.replace(/^\|/, '');
          score = score.replace(/^\|/, '');
        }
        // }
        this.setData({
          item: item,
        })
      }
      // 以上社区工作者
      this.setData({
        active: index,
        // active: -1,
        all: len,
        current: Number(record),
        disab: false,
      })
      if (answer_swiper.score.length <= record) {
        answer_swiper.score.push(score);
        answer_swiper.answer.push(index);
      } else {
        answer_swiper.score[record] = score;
        answer_swiper.answer[record] = index;
      }
      if (that.data.bid.id == 635 && e.currentTarget.dataset.record == 17) {
        answer_swiper.score[17] = that.data.shengfen;
        answer_swiper.answer[17] = 0;
      }
      // if (wx.getStorageSync('canvas')){
      //   console.log(wx.getStorageSync('canvas'))
      //   answer_swiper.unshift(wx.getStorageSync('canvas'));
      //   answer_swiper.unshift(0);
      // }
      wx.setStorageSync('answer_swiper', answer_swiper);
    } else {}
  },
  prev: function (e) {
    if (this.data.current > 0) {
      if (this.data.bid.id == 632 && this.data.current == 24) {
        var record = 18;
      } else {
        console.log(this.data.current, 'this.data.current')
        var record = this.data.current - 1;
      }
      this.prevAnimation();
      var swiper_arr = wx.getStorageSync('swiper_arr');
      let len = swiper_arr[1].length;
      var answer_swiper = wx.getStorageSync('answer_swiper');
      var item = swiper_arr[1][record];
      var nextFalg = this.data.nextFalg;
      nextFalg[record] = true;
      // 多选题 的数据状态
      if (this.data.multipleChoice && (record == 4 || record == 8 || record == 9 || record == 10 || record == 14)) {
        let ans = answer_swiper.answer[record];
        let ansArr = ans.split('|');
        for (let i = 0; i < ansArr.length; i++) {
          item.check[ansArr[i]] = 1;
        }
      } else if (this.data.sheqv && (record == 12 || record == 19)) {
        let ans = answer_swiper.answer[record];
        let ansArr = ans.split('|');
        for (let i = 0; i < ansArr.length; i++) {
          item.check[ansArr[i]] = 1;
        }
      } else if (this.data.attitudeSurvey && (record == 4 || record == 5 || record == 6 || record == 7)) {
        let ans = answer_swiper.answer[record];
        let ansArr = ans.split('|');
        for (let i = 0; i < ansArr.length; i++) {
          item.check[ansArr[i]] = 1;
        }
      }
      this.setData({
        active: answer_swiper.answer[Number(record)],
        current: record,
        item: item,
        nextFalg: nextFalg
      })
    }

  },

  next: function (n) {
    // console.log(n, this.data.bid.id)
    if (this.data.multipleChoice || this.data.sheqv || this.data.attitudeSurvey) {
      n = n.currentTarget.dataset.cur;
    }
    var answer_swiper = wx.getStorageSync('answer_swiper');
    if (answer_swiper.answer[n].length <= 0) {
      wx.showToast({
        title: '请选择',
        icon: 'none',
        duration: 1000
      });
      return;
    }
    var swiper_arr = wx.getStorageSync('swiper_arr');
    let len = swiper_arr[1].length;
    if (n < len) {
      // this.nextAnimation();
      var item = swiper_arr[1][n + 1]
      var answer_swiper = wx.getStorageSync('answer_swiper');
      var an_len = answer_swiper.answer ? answer_swiper.answer.length : -1;
      if (an_len - n > 1) {
        // 多选题 的数据状态
        if (this.data.multipleChoice && (n + 1 == 4 || n + 1 == 8 || n + 1 == 9 || n + 1 == 10 || n + 1 == 14)) {
          let ans = answer_swiper.answer[n + 1];
          let ansArr = ans.split('|');
          for (let i = 0; i < ansArr.length; i++) {
            item.check[ansArr[i]] = 1;
          }
        } else if (this.data.sheqv && (n + 1 == 12 || n + 1 == 19)) {
          let ans = answer_swiper.answer[n + 1];
          let ansArr = ans.split('|');
          for (let i = 0; i < ansArr.length; i++) {
            item.check[ansArr[i]] = 1;
          }
        } else if (this.data.attitudeSurvey && (n + 1 == 4 || n + 1 == 5 || n + 1 == 6 || n + 1 == 7)) {
          let ans = answer_swiper.answer[n + 1];
          let ansArr = ans.split('|');
          for (let i = 0; i < ansArr.length; i++) {
            item.check[ansArr[i]] = 1;
          }
        }
        this.setData({
          active: answer_swiper.answer[n + 1],
          // active: -1,
          item: item,
          all: len,
          current: n + 1
        })
      } else {
        this.setData({
          active: -1,
          item: item,
          all: len,
          current: n + 1
        })
      }

    } else if (n == len) {
      console.log('tijiao')
      // this.tijiao();
    } else {
      console.log('meiyouti')
    }

  },
  next1: function (n) {
    // console.log(n, this.data.bid.id)
    if (this.data.multipleChoice || this.data.sheqv || this.data.attitudeSurvey) {
      n = n;
    }
    var answer_swiper = wx.getStorageSync('answer_swiper');
    if (answer_swiper.answer[n].length <= 0) {
      wx.showToast({
        title: '请选择',
        icon: 'none',
        duration: 1000
      });
      return;
    }
    var swiper_arr = wx.getStorageSync('swiper_arr');
    let len = swiper_arr[1].length;
    if (n < len) {
      // this.nextAnimation();
      var item = swiper_arr[1][n + 1]
      var answer_swiper = wx.getStorageSync('answer_swiper');
      var an_len = answer_swiper.answer ? answer_swiper.answer.length : -1;
      if (an_len - n > 1) {
        // 多选题 的数据状态
        if (this.data.multipleChoice && (n + 1 == 4 || n + 1 == 8 || n + 1 == 9 || n + 1 == 10 || n + 1 == 14)) {
          let ans = answer_swiper.answer[n + 1];
          let ansArr = ans.split('|');
          for (let i = 0; i < ansArr.length; i++) {
            item.check[ansArr[i]] = 1;
          }
        } else if (this.data.sheqv && (n + 1 == 12 || n + 1 == 19)) {
          let ans = answer_swiper.answer[n + 1];
          let ansArr = ans.split('|');
          for (let i = 0; i < ansArr.length; i++) {
            item.check[ansArr[i]] = 1;
          }
        } else if (this.data.attitudeSurvey && (n + 1 == 4 || n + 1 == 5 || n + 1 == 6 || n + 1 == 7)) {
          let ans = answer_swiper.answer[n + 1];
          let ansArr = ans.split('|');
          for (let i = 0; i < ansArr.length; i++) {
            item.check[ansArr[i]] = 1;
          }
        }
        this.setData({
          active: answer_swiper.answer[n + 1],
          // active: -1,
          item: item,
          all: len,
          current: n + 1
        })
      } else {
        this.setData({
          active: -1,
          item: item,
          all: len,
          current: n + 1
        })
      }

    } else if (n == len) {
      console.log('tijiao')
      // this.tijiao();
    } else {
      console.log('meiyouti')
    }

  },
  nextAnimation: function () {
    var that = this;
    var _thisWidth = Number(this.data.winW);
    var animation = wx.createAnimation({
      duration: 400,
      timingFunction: 'linear',
    })
    this.animation = animation
    animation.left(-_thisWidth).opacity(0).step();
    this.setData({
      animationData: animation.export()
    })
    setTimeout(function () {
      var animation1 = wx.createAnimation({
        duration: 0,
        timingFunction: 'step-start',
      })
      that.animation = animation1
      animation1.left(_thisWidth / 2).opacity(1).step();
      that.setData({
        animationData: animation1.export()
      })
    }, 410)
  },
  prevAnimation: function () {
    var that = this;
    var _thisWidth = Number(this.data.winW);
    var animation = wx.createAnimation({
      duration: 300,
      timingFunction: 'linear',
    })
    this.animation = animation
    animation.left(_thisWidth * 2).opacity(1).step();
    this.setData({
      animationData: animation.export()
    })
    setTimeout(function () {
      var animation1 = wx.createAnimation({
        duration: 0,
        timingFunction: 'step-start',
      })
      that.animation = animation1
      animation1.left(_thisWidth / 2).opacity(1).step();
      that.setData({
        animationData: animation1.export()
      })
    }, 310)
  },
  dealPho(str, host) {
    return str.replace("./", host);
  },
  onShow: function () {
    let that = this;
    var lb_descript = wx.getStorageSync('lb_descript');
    console.log(lb_descript.id[0] == 3)
    var judgeSex = wx.getStorageSync('judgeSex');
    var sex = 1;
    // 量表id 
    if (lb_descript.id[0] == 3 && judgeSex == 1) {
      sex = 2;
    } else if (lb_descript.id[0] == 3 && judgeSex == 0) {
      sex = 3;
    } else {
      sex = 1;
    }
    var cmi = -1;
    if (lb_descript.id[0] == 3 && judgeSex == 1) {
      cmi = 1
    } else if (lb_descript.id[0] == 3 && judgeSex == 0) {
      cmi = 0;
    }
    // 心理咨询认同性调查报告

    var multipleChoice = false;
    var sheqv = false;
    var attitudeSurvey = false;
    if (lb_descript.id[0] == 523 || lb_descript.id[0] == 626 || lb_descript.id[0] == 620 || lb_descript.id[0] == 636) {
      multipleChoice = true;
    }
    if (lb_descript.id[0] == 632) {
      sheqv = true;
    }
    if (lb_descript.id[0] == 713) {
      attitudeSurvey = true;
    }
    // 社会支持评定
    var shzcpd = false;
    if (lb_descript.id[0] == 444 || lb_descript.id[0] == 724) {
      shzcpd = true;
    }
    // 匹兹堡
    var pizibao = false;
    if (lb_descript.id[0] == 16 || lb_descript.id[0] == 624 || lb_descript.id[0] == 628 || lb_descript.id[0] == 630||lb_descript.id[0] == 807) {
      pizibao = true;
    }
    // 绵竹三院心里体检
    var pizibao1 = false;
    if (lb_descript.id[0] == 721) {
      pizibao1 = true;
    }
    //霍兰德倾向
    var hollander = false;
    // console.log('霍兰德倾向', this.data.item)
    if (lb_descript.id[0] == 144) {
      hollander = true;
    }
    var xljksy = false;
    // console.log('霍兰德倾向', this.data.item)
    if (lb_descript.id[0] == 835) {
      xljksy = true;
    }
    this.setData({
      judgeSex: sex,
      pizibao: pizibao,
      pizibao1: pizibao1,
      shzcpd: shzcpd,
      hollander: hollander,
      xljksy:xljksy,
      cmi: cmi,
      multipleChoice: multipleChoice,
      sheqv: sheqv,
      attitudeSurvey: attitudeSurvey
    })
    var swiper_arr = wx.getStorageSync('swiper_arr');
    if (swiper_arr) {
      wx.setNavigationBarTitle({
        title: swiper_arr[0].measure_name
      });
    }

    wx.getSystemInfo({
      success: (res) => {
        that.setData({
          // winH: res.windowHeight,
          winW: res.windowWidth,
        })
      }
    });
    var startTime = Date.parse(new Date());
    var cha = wx.getStorageSync('chaTime') ? wx.getStorageSync('chaTime') : 0;
    wx.setStorageSync('startTime', Number(startTime));
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {
    var endtTime = Date.parse(new Date());
    var startTime = wx.getStorageSync('startTime');
    var cha = endtTime - startTime;
    var arr = wx.getStorageSync("timeArr");
    if (Number(cha) < 1000000040000) {
      arr.push(Number(cha))
      wx.setStorageSync("timeArr", arr);
    }
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    var endtTime = Date.parse(new Date());
    var startTime = wx.getStorageSync('startTime');
    var cha = endtTime - startTime;
    var arr = wx.getStorageSync("timeArr");
    if (Number(cha) < 1000000040000) {
      arr.push(Number(cha))
      wx.setStorageSync("timeArr", arr);
    }
    wx.removeStorageSync('canvas')
  },
  shengfen: function (e) {
    var answer_swiper = wx.getStorageSync('answer_swiper');
    var that = this
    this.setData({
      shengfen: e.detail.value
    })
    answer_swiper.score[17] = that.data.shengfen;
    answer_swiper.answer[17] = 0;
    wx.setStorageSync('answer_swiper', answer_swiper);
  },
  pici: function (e) {
    var answer_swiper = wx.getStorageSync('answer_swiper');
    var that = this
    this.setData({
      pici: e.detail.value
    })
    answer_swiper.score[18] = that.data.pici;
    answer_swiper.answer[18] = 0;
    wx.setStorageSync('answer_swiper', answer_swiper);
  },
  tijiao: function () {
    let that = this;
    var lb_descript = wx.getStorageSync('lb_descript');
    if (lb_descript.id[0] == 635 && (that.data.shengfen == '' || that.data.pici == '')) {
      wx.showToast({
        title: '请选择省份和批次',
        icon: 'none',
        duration: 1000
      });
      return;
    }
    if (lb_descript.id[0] == 523) {
      var ans = wx.getStorageSync('answer_swiper')
      if (ans.answer[ans.answer.length - 1].length <= 0) {
        wx.showToast({
          title: '请选择',
          icon: 'none',
          duration: 1000
        });
        return;
      }
    }
    if (lb_descript.id[0] == 713) {
      var ans = wx.getStorageSync('answer_swiper')
      if (ans.answer[ans.answer.length - 1].length <= 0) {
        wx.showToast({
          title: '请选择',
          icon: 'none',
          duration: 1000
        });
        return;
      }
    }
    if (this.data.flag && !this.disab) {
      this.setData({
        flag: false
      })
      wx.showLoading({
        title: '上传中...',
        mask: true,
      })
      // var timer = setTimeout(function () {
      //   wx.showToast({
      //     title: '请稍后再试',
      //     icon: 'none',
      //     duration: 2000,
      //     success: function () {

      //     }
      //   })
      // }, 8000)
      var startTime = wx.getStorageSync('startTime');
      var timeArr = wx.getStorageSync('timeArr');
      var chaTime = 0;
      for (let i = 0; i < timeArr.length; i++) {
        if (Number(timeArr) > 1000000040000) {
          timeArr[i] = 0;
        }
        chaTime += timeArr[i]
      }
      var thisTime = Date.parse(new Date());
      var cha = thisTime - startTime + chaTime;
      var time = Api.reversalTime(cha)
      var user = wx.getStorageSync('user');
      var answer = wx.getStorageSync('answer_swiper');
      for (let i = 0; i < answer.score.length; i++) {
        answer.score[i] = answer.score[i].replace(/[\r\n]/g, '');
      }
      var lb_descript = wx.getStorageSync('lb_descript');
      var swiper_arr = wx.getStorageSync('swiper_arr');
      var lb_tp = wx.getStorageSync('lb_tz')
      if (wx.getStorageSync('canvas')) {
        answer.score.unshift(wx.getStorageSync('canvas'));
        answer.answer.unshift(0);
      }
      var stoUser = wx.getStorageSync('user');
      var ndata = {
        measure_id: lb_descript.id[0],
        user_stime: time,
        g_id: wx.getStorageSync('g_id'),
        openid:stoUser.openid ? stoUser.openid : '',
        user_answer: answer.score,
        answer: answer.answer,
     };
     var lb_tz = wx.getStorageSync('lb_tz');
     if (lb_tz == '1') {
       ndata.is_type = 0;
     } else {
       ndata.is_type = 1;
     }
     
     var url = Api.HOST_xlxl + 'amedical.php/gauge/pcAddData';
     ndata.unitid = lb_descript.desc.unitid;
     ndata.uid = 6;
     ndata.submit_type = 2;
     ndata.t_openid = wx.getStorageSync('param_t_openid');
      var uploadData = setTimeout(function () {
        wx.hideLoading()
        wx.showToast({
          icon: 'none',
          title: '您当前的网络不稳定，请检查网络重新提交',
          duration: 2000
        })
        that.setData({
          flag: true
        })
      }, 5000)
      var formdata = wx.getStorageSync('allUserinfo');
      let newdata = Object.assign({...ndata,...formdata});
      newdata = this.removeEmptyProperties(newdata);
      Api.fetchPostN(url, newdata, (err, res) => {
        clearTimeout(uploadData)
        if (Number(res) == 0) {
          Api.alert("提交失败，请重新提交。")
          return;
        } else if (Number(res.code) == -1) {
            wx.hideLoading();
            Api.alert(res.msg)
            that.setData({
                flag: true
            })
            return;
        } else {
            that.setData({
                flag: true
            })
            if (res.data.charactersStatus == 1 || res.data.charactersStatus == 0) {
                wx.removeStorageSync('answer_swiper')
                wx.removeStorageSync('swiper_arr')
                wx.removeStorageSync('chaTime')
                wx.removeStorageSync('endTime')
                wx.removeStorageSync('startTime')
                wx.removeStorageSync('timeArr')
                wx.removeStorageSync('lb_swiper_con')
                wx.hideLoading();
              } else {
                wx.hideLoading()
                wx.showToast({
                  title: '请稍后再试',
                  icon: 'none',
                  duration: 2000
                })
              }
              if (res.data.charactersStatus == 1) {
                wx.showToast({
                  title: '上传成功',
                  icon: 'success',
                  duration: 2000
                })
                wx.removeStorageSync('canvas')
                setTimeout(function () {
                  var lb_tz = wx.getStorageSync('lb_tz');
                  if (lb_tz == '1') {
                    wx.reLaunch({
                      url: '/pages/info1/info1?otype=1&otype1=1',
                      success: function () {
                        that.setData({
                          flag: true
                        })
                      }
                    })
                  } else {
                    var g_id = wx.getStorageSync('g_id');
                    wx.reLaunch({
                      url: `/pages/info/info?otype=1&otype1=1&ishow=1&g_id=${g_id}`,
                      success: function () {
                        that.setData({
                          flag: true
                        })
                      }
                    })
                  }
                }, 2000)
              } else if (res.data.charactersStatus == 0) {
                wx.showToast({
                  title: '上传成功',
                  icon: 'success',
                  duration: 2000
                })
                setTimeout(function () {
                  wx.removeStorageSync('tplbDetail')
                  wx.removeStorageSync('weiLb')
                  wx.reLaunch({
                    url: '/pages/record/record',
                    success: function () {
                      that.setData({
                        flag: true
                      })
                      wx.removeStorageSync('lb_descript');
                      wx.removeStorageSync('allUserinfo');
                      wx.removeStorageSync('g_id');
                      wx.removeStorageSync('param_t_openid');
                    }
                  })
                }, 2000)
              } 
        }
        // var swiper_arr = wx.getStorageSync('swiper_arr');
        // var data1 = {};
        // var urls = Api.HOST_xlxl + 'wechat.php?s=Home/del_vips';
        // var ti_title = swiper_arr[0].measure_name;
        // var lb_descript = wx.getStorageSync("lb_descript");
        // var authorize = wx.getStorageSync('weiLb');
        // data1.g_time = lb_descript.desc.g_time || lb_descript.desc.time;
        // data1.measure_name = ti_title;
        // data1.user_stime = time;
        // data1.characters_id = authorize.characters_id ? authorize.characters_id : authorize.record_id;
        // var lb_tz = wx.getStorageSync('lb_tz');
        // if (lb_tz == '1') {
        //   var unitid = wx.getStorageSync("unitid");
        //   var tp_characters_id = wx.getStorageSync("tplbDetail");
        //   data1.unitid = unitid;
        //   data1.characters_id = tp_characters_id.g_id;
        //   data1.z_openid = lb_descript.desc.z_openid;
        //   data1.t_openid = lb_descript.desc.t_openid;
        //   data1.openid = lb_descript.desc.z_openid;
        //   data1.is_type = 0;
        //   data1.measure_id = lb_descript.id[0];
        // } else {
        //   data1.z_openid = user.openid;
        //   data1.t_openid = lb_descript.desc.t_openid;
        //   data1.openid = user.openid;
        //   data1.is_type = 1;
        //   data1.unitid = lb_descript.desc.unitid;
        //   data1.measure_id = lb_descript.id[0];
        // }
        // clearTimeout(timer)
        // Api.fetchPost(urls, data1, (err, res) => {
        // //   console.log('5555555555555', res)
        //   if (err) {
        //     that.setData({
        //       flag: true
        //     })
        //   }
        //   that.setData({
        //     flag: true
        //   })
        //   if (res == 1 || res == 0) {
        //     wx.removeStorageSync('answer_swiper')
        //     wx.removeStorageSync('swiper_arr')
        //     wx.removeStorageSync('chaTime')
        //     wx.removeStorageSync('endTime')
        //     wx.removeStorageSync('startTime')
        //     wx.removeStorageSync('timeArr')
        //     wx.removeStorageSync('lb_swiper_con')
        //     wx.hideLoading();

        //   } else {
        //     wx.hideLoading()
        //     wx.showToast({
        //       title: '请稍后再试',
        //       icon: 'none',
        //       duration: 2000
        //     })
        //   }

        // //   console.log('res', res)

        //   if (res == 1) {
        //     // clearTimeout(timer)
        //     wx.showToast({
        //       title: '上传成功',
        //       icon: 'success',
        //       duration: 2000
        //     })
        //     wx.removeStorageSync('canvas')
        //     setTimeout(function () {
        //       var lb_tz = wx.getStorageSync('lb_tz');
        //       if (lb_tz == '1') {
        //         wx.reLaunch({
        //           url: '/pages/info1/info1?otype=1&otype1=1',
        //           success: function () {
        //             that.setData({
        //               flag: true
        //             })
        //           }
        //         })
        //       } else {
        //         var g_id = wx.getStorageSync('g_id');
        //         wx.reLaunch({
        //           url: `/pages/info/info?otype=1&otype1=1&ishow=1&g_id=${g_id}`,
        //           success: function () {
        //             that.setData({
        //               flag: true
        //             })
        //           }
        //         })
        //       }
        //     }, 2000)
        //   } else if (res == 0) {
        //     // clearTimeout(timer)
        //     wx.showToast({
        //       title: '上传成功',
        //       icon: 'success',
        //       duration: 2000
        //     })
        //     setTimeout(function () {
        //       wx.removeStorageSync('tplbDetail')
        //       wx.removeStorageSync('weiLb')
        //       wx.reLaunch({
        //         // url: '/pages/end/end?lbtype=-1',
        //         url: '/pages/record/record',
        //         success: function () {
        //           that.setData({
        //             flag: true
        //           })
        //           wx.removeStorageSync('lb_descript');
        //           wx.removeStorageSync('allUserinfo');
        //           wx.removeStorageSync('g_id');
        //           wx.removeStorageSync('param_t_openid');
        //         }
        //       })
        //     }, 2000)
        //   } else {

        //   }
        // })
      })
    }
  },
  onReady: function () {
    let that = this;
    // setTimeout(function () {
    wx.getSystemInfo({
      success: (res) => {
        if (/^iPhone X.*/i.test(res.model)) {
          that.setData({
            iPhoneX: true,
            winH: res.windowHeight - 118
          })
        } else {
          that.setData({
            iPhoneX: false,
            winH: res.windowHeight - 118
          })
        }
      }
    });
    // }, 600)
  },
  pitime: function (e) {
    // console.log(e)
    var txt = e.detail.value;
    var num = Number(txt);
    if (num >= 0 && num < 24) {
      console.log(num, "num")
      if (num < 10) {
        console.log(num, "num")
        txt = '0' + num;
        // console.log(0 < num < 10,"pp")
      }
      // console.log(txt)
      if (this.data.current == 0||this.data.current == 55) {
        this.setData({
          ptime1: txt
        })
      } else if (this.data.current == 2||this.data.current == 57) {
        this.setData({
          ptime2: txt
        })
      } else if (this.data.current == 3||this.data.current == 58) {
        this.setData({
          ptime3: txt
        })
      }
    } else {
      if (this.data.current == 0||this.data.current == 55) {
        this.setData({
          ptime1: ""
        })
      } else if (this.data.current == 2||this.data.current == 57) {
        this.setData({
          ptime2: ""
        })
      } else if (this.data.current == 3||this.data.current == 58) {
        this.setData({
          ptime3: ""
        })
      }

    }
  },
  piminute: function (e) {
    var txt1 = e.detail.value;
    var num1 = Number(txt1);
    if (num1 >= 0 && num1 < 60) {
      if (num1 < 10) {
        txt1 = '0' + num1;
      }
      if (this.data.current == 0||this.data.current == 55) {
        this.setData({
          pminute1: txt1
        })
      } else if (this.data.current == 2||this.data.current == 57) {
        this.setData({
          pminute2: txt1
        })
      } else if (this.data.current == 3||this.data.current == 58) {
        this.setData({
          pminute3: txt1
        })
      }

    } else {
      if (this.data.current == 0||this.data.current == 55) {
        this.setData({
          pminute1: ""
        })
      } else if (this.data.current == 2||this.data.current == 57) {
        this.setData({
          pminute2: ""
        })
      } else if (this.data.current == 3||this.data.current == 58) {
        this.setData({
          pminute3: ""
        })
      }

    }
  },
  pbtn: function () {
    let that = this;
    console.log("current",this.data.current)
    if (this.data.current == 0 || this.data.current == 55) {
      var ptime = this.data.ptime1;
      var pminute = this.data.pminute1;
    } else if (this.data.current == 2 || this.data.current == 57) {
      var ptime = this.data.ptime2;
      var pminute = this.data.pminute2;
    } else if (this.data.current == 3 || this.data.current == 58) {
      var ptime = this.data.ptime3;
      var pminute = this.data.pminute3;
    }

    if (Number(ptime) < 0 || Number(pminute) < 0 || Number(ptime) > 24 || Number(pminute) > 60 || ptime == "" || pminute == "") {
      console.log("this")
    } else {
      console.log("that")
      wx.hideKeyboard()
      var str = ptime + ":" + pminute;
      console.log(str, 'str')
      var answer_swiper = wx.getStorageSync("answer_swiper");
      var num = this.data.current; // 从0开始 不用加1 和数组下标对应
      answer_swiper.answer[num] = str;
      answer_swiper.score[num] = str;
      wx.setStorageSync("answer_swiper", answer_swiper)
      setTimeout(function () {
        that.next(num);
        that.setData({
          ptime: "",
          pminute: ""
        })
      }, 200)
    }
  },
  removeEmptyProperties:function (obj) {
    // 将对象转换为 [key, value] 数组
    const entries = Object.entries(obj);
    // 过滤掉属性值为空字符串的属性
    const filteredEntries = entries.filter(([key, value]) => value !== ""&&value != 0&&value != 'undefined'&&value != null&&value != 'null'&&value != 'NULL');
    // 将过滤后的数组转换回对象
    const filteredObj = Object.fromEntries(filteredEntries);
    return filteredObj;
  },
})